servo/models/__init__.py
# -*- coding: utf-8 -*-

from .common import *
from .product import *
from .account import *
from .queue import *
from .customer import *
from .device import *
from .note import *
from .order import *
from .invoices import *
from .purchases import *
from .shipments import *
from .parts import *
from .repair import *
from .escalations import *
from .rules import *

servo/models/product.py
# -*- coding: utf-8 -*-

import re
from os.path import basename
from decimal import Decimal, ROUND_CEILING

from django.db import models
from django.db import connection
from django.urls import reverse
from django.conf import settings
from django.core.files import File
from django.core.cache import cache

from django.contrib.contenttypes.fields import GenericRelation

from django.utils.translation import ugettext_lazy as _

from mptt.managers import TreeManager
from gsxws import comptia, parts, validate
from mptt.models import MPTTModel, TreeForeignKey

from servo import defaults
from servo.lib.shorturl import from_time
from servo.models import Configuration, Location, TaggedItem


def get_margin(price=0.0):
    """
    Returns the proper margin % for this price
    """
    price  = Decimal(price)
    margin = defaults.margin()

    try:
        return Decimal(margin)
    except Exception:
        ranges = margin.split(';')
        for r in ranges:
            m = re.search(r'(\d+)\-(\d+)=(\d+)', r)
            p_min, p_max, margin = m.groups()
            if Decimal(p_min) <= price <= Decimal(p_max):
                return Decimal(margin)

    return Decimal(margin)


def default_vat():
    conf = Configuration.conf()
    return conf.get("pct_vat", 0.0)


def inventory_totals():
    """
    Returns the total purchase and sales value
    of our inventory
    """
    cursor = connection.cursor()
    sql = """SELECT SUM(price_purchase_stock*total_amount) AS a,
    SUM(price_sales_stock*total_amount) AS b
    FROM servo_product
    WHERE part_type != 'SERVICE'"""
    cursor.execute(sql)

    for k, v in cursor.fetchall():
        return (k, v)


class DeviceGroup(models.Model):
    """
    This links products with devices.
    The title should match a device's description field
    """
    title = models.CharField(max_length=128, unique=True)

    class Meta:
        app_label = "servo"


class AbstractBaseProduct(models.Model):
    code = models.CharField(
        unique=True,
        max_length=32,
        default=from_time,
        verbose_name=_("Code")
    )

    subst_code = models.CharField(
        default='',
        max_length=32,
        editable=False,
        verbose_name=_("Substituted (new) code of this part")
    )

    title = models.CharField(
        max_length=255,
        default=_("New Product"),
        verbose_name=_("Title")
    )
    description = models.TextField(
        default='',
        blank=True,
        verbose_name=_("Description")
    )
    pct_vat = models.DecimalField(
        max_digits=4,
        decimal_places=2,
        default=default_vat,
        verbose_name=_("VAT %")
    )

    currency = models.CharField(
        max_length=3,
        default='',
        editable=False,
    )

    fixed_price = models.BooleanField(
        default=False,
        help_text=_("Don't update price when recalculating prices or importing parts")
    )

    price_purchase_exchange = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Purchase price")
    )

    pct_margin_exchange = models.DecimalField(
        max_digits=4,
        decimal_places=2,
        default=get_margin,
        verbose_name=_("Margin %")
    )
    price_notax_exchange = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Net price"),
        help_text=_("Purchase price + margin %")
    )
    price_sales_exchange = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Sales price"),
        help_text=_("Purchase price + margin % + shipping + VAT %")
    )

    price_purchase_stock = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Purchase price")
    )
    pct_margin_stock = models.DecimalField(
        max_digits=4,
        decimal_places=2,
        default=get_margin,
        verbose_name=_("Margin %")
    )
    price_notax_stock = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Net price"),
        help_text=_("Purchase price + margin %")
    )
    price_sales_stock = models.DecimalField(
        default=0,
        max_digits=8,
        decimal_places=2,
        verbose_name=_("Sales price"),
        help_text=_("Purchase price + margin % + shipping + VAT %")
    )

    is_serialized = models.BooleanField(
        default=False,
        verbose_name=_('Is serialized'),
        help_text=_("Product has a serial number")
    )

    class Meta:
        app_label = 'servo'
        abstract = True


class Product(AbstractBaseProduct):
    """
    An item in the inventory
    """
    warranty_period = models.PositiveIntegerField(
        default=0,
        verbose_name=_("Warranty (months)")
    )
    shelf = models.CharField(
        default='',
        blank=True,
        max_length=8,
        verbose_name=_("Shelf code")
    )
    brand = models.CharField(
        default='',
        blank=True,
        max_length=32,
        verbose_name=_("Brand")
    )
    categories = models.ManyToManyField(
        "ProductCategory",
        blank=True,
        verbose_name=_("Categories"),
        help_text=_("Product categories"),
    )
    device_models = models.ManyToManyField(
        "DeviceGroup",
        blank=True,
        verbose_name=_("Device models"),
        help_text=_("Compatible with these devices"),
    )
    tags = GenericRelation(TaggedItem)
    photo = models.ImageField(
        null=True,
        blank=True,
        upload_to="products",
        verbose_name=_("Photo")
    )

    shipping = models.FloatField(default=0, verbose_name=_('Shipping'))

    # component code is used to identify Apple parts
    component_code = models.CharField(
        blank=True,
        default='',
        max_length=1,
        choices=comptia.GROUPS,
        verbose_name=_("Component group")
    )

    labour_tier = models.CharField(max_length=15, blank=True, default='')

    # We need this to call the correct GSX SN Update API
    PART_TYPES = (
        ('ADJUSTMENT',  _("Adjustment")),
        ('MODULE',      _("Module")),
        ('REPLACEMENT', _("Replacement")),
        ('SERVICE',     _("Service")),
        ('SERVICE CONTRACT', _("Service Contract")),
        ('OTHER',       _("Other")),
    )

    part_type = models.CharField(
        max_length=18,
        default='OTHER',
        choices=PART_TYPES,
        verbose_name=_("Part type")
    )

    eee_code = models.CharField(
        blank=True,
        default='',
        max_length=256,
        verbose_name=_("EEE code")
    )

    total_amount = models.IntegerField(editable=False, default=0)

    def get_pick_url(self, order, device=None):
        pk = self.pk or self.code
        return '/orders/%d/devices/%d/'

    def is_service(self):
        return self.part_type == 'SERVICE'

    def get_warranty_display(self):
        if self.warranty_period:
            return _("%d months") % self.warranty_period

    def can_order_from_gsx(self):
        ok_types = ("MODULE", "REPLACEMENT", "OTHER",)
        return self.component_code and self.part_type in ok_types

    def can_update_price(self):
        return self.can_order_from_gsx() and not self.fixed_price

    def update_price(self, new_product=None):
        """
        Updates part's price info from GSX or to match new_product
        """
        if new_product is None:
            part = parts.Part(partNumber=self.code).lookup()
            new_product = Product.from_gsx(part)

        self.price_purchase_exchange = new_product.price_purchase_exchange
        self.price_purchase_stock = new_product.price_purchase_stock

        self.title = new_product.title

        self.component_code = new_product.component_code

        self.price_notax_stock = new_product.price_notax_stock
        self.price_notax_exchange = new_product.price_notax_exchange

        self.pct_margin_stock = new_product.pct_margin_stock
        self.pct_margin_exchange = new_product.pct_margin_exchange

        self.price_sales_stock = new_product.price_sales_stock
        self.price_sales_exchange = new_product.price_sales_exchange

        self.save()

    def calculate_price(self, price, shipping=0.0):
        """
        Calculates price and returns it w/ and w/o tax
        """
        conf = Configuration.conf()
        shipping = shipping or 0.0

        if not isinstance(shipping, Decimal):
            shipping = Decimal(shipping)

        margin = get_margin(price)
        vat = Decimal(conf.get("pct_vat", 0.0))

        # TWOPLACES = Decimal(10) ** -2  # same as Decimal('0.01')
        # @TODO: make rounding configurable!
        wo_tax = ((price*100)/(100-margin)+shipping).to_integral_exact(rounding=ROUND_CEILING)
        with_tax = (wo_tax*(vat+100)/100).to_integral_exact(rounding=ROUND_CEILING)

        return wo_tax, with_tax

    def set_stock_sales_price(self):
        if not self.price_purchase_stock or self.fixed_price:
            return

        purchase_sp = self.price_purchase_stock
        sp, vat_sp  = self.calculate_price(purchase_sp, self.shipping)
        self.price_notax_stock = sp
        self.price_sales_stock = vat_sp

    def set_exchange_sales_price(self):
        if not self.price_purchase_exchange or self.fixed_price:
            return

        purchase_ep = self.price_purchase_exchange
        ep, vat_ep  = self.calculate_price(purchase_ep, self.shipping)
        self.price_notax_exhcange = ep
        self.price_sales_exchange = vat_ep

    @property
    def is_apple_part(self):
        return validate(self.code, 'partNumber')

    @classmethod
    def from_gsx(cls, part):
        """
        Creates a Servo Product from GSX partDetail.
        We don't do GSX lookups here since we can't
        determine the correct GSX Account at this point.
        """
        conf = Configuration.conf()

        try:

servo/forms/__init__.py
# -*- coding: utf-8 -*-

from .base import *
from .orders import *
from .notes import *
from .devices import *
from .product import *
from .repairs import *
from .checkin import *

servo/forms/account.py
# -*- coding: utf-8 -*-

from django import forms
from django.utils.translation import ugettext_lazy as _

from servo.forms.base import BaseForm, BaseModelForm
from servo.models.account import User


class ProfileForm(BaseModelForm):
    # User Profile form for users
    class Meta:
        model = User
        fields = (
            "location",
            "photo",
            "locale",
            "queues",
            "region",
            "timezone",
            "should_notify",
            "notify_by_email",
            "autoprint",
            "tech_id",
            "gsx_userid",
            "gsx_poprefix",
        )
        widgets = {
            'queues': forms.CheckboxSelectMultiple
        }
        
    password1 = forms.CharField(widget=forms.PasswordInput,
                                required=False,
                                label=_("Password"))
    password2 = forms.CharField(widget=forms.PasswordInput,
                                required=False,
                                label=_("Confirmation"))

    def clean(self):
        cd = super(ProfileForm, self).clean()

        if cd.get('gsx_password') == "":
            del(cd['gsx_password'])

        cd['tech_id'] = cd['tech_id'].upper()

        if cd.get('password1'):
            if cd['password1'] != cd['password2']:
                raise forms.ValidationError(_("Password and confirmation do not match!"))

        return cd

    def clean_photo(self):
        MAX_FILESIZE = 1*1024*1024 # 1 MB
        from django.template.defaultfilters import filesizeformat
        photo = self.cleaned_data.get('photo')
        if photo and photo.size > MAX_FILESIZE:
            size = filesizeformat(MAX_FILESIZE)
            error = _('Profile picture should be no larger than %s') % size
            raise forms.ValidationError(error)

        return photo


class RegistrationForm(BaseForm):
    first_name = forms.CharField(label=_("First Name"))
    last_name = forms.CharField(label=_("Last Name"))
    email = forms.EmailField(label=_("Email Address"))
    password = forms.CharField(widget=forms.PasswordInput, label=_("Password"))


class LoginForm(BaseForm):
    username = forms.CharField(
        widget=forms.TextInput(attrs={'placeholder': _('Username')})
    )
    password = forms.CharField(
        widget=forms.PasswordInput(attrs={'placeholder': _('Password')})
    )

servo/forms/base.py
# -*- coding: utf-8 -*-

import json
from django import forms
from django.forms.utils import flatatt
from django.utils.html import format_html
from django.utils.safestring import mark_safe


class NullCharField(forms.CharField):
    def clean(self, value):
        cleaned = super(NullCharField, self).clean(value)
        return cleaned if len(cleaned) else None


class FullTextArea(forms.CharField):
    widget = forms.Textarea(attrs={'class': 'span12'})


class SearchField(forms.CharField):
    widget = forms.TextInput(attrs={
        'class': 'search-query',
        'autocomplete': 'off',
        'placeholder': '',
    })


class ChoiceField(forms.ChoiceField):
    def __init__(self, *args, **kwargs):
        super(ChoiceField, self).__init__(*args, **kwargs)
        self.widget.attrs['class'] = 'span12'


class TextInput(forms.TextInput):
    def __init__(self, *args, **kwargs):
        super(TextInput, self).__init__(*args, **kwargs)
        self.attrs['class'] = 'span12'


class AutocompleteCharField(forms.CharField):
    widget = forms.TextInput(attrs={
        'class': "input typeahead",
        'data-provide': "typeahead"
    })

    def __init__(self, values, *args, **kwargs):
        super(AutocompleteCharField, self).__init__(*args, **kwargs)

        if not type(values) is str:
            values = json.dumps(list(values))

        self.widget.attrs['data-source'] = values


class AutocompleteTextarea(forms.Textarea):
    def __init__(self, rows=8, choices=None):
        super(AutocompleteTextarea, self).__init__()
        self.attrs = {
            'rows': rows,
            'class': "span12 autocomplete",
            'data-source': json.dumps(choices)
        }


class BaseForm(forms.Form):
    required_css_class = "required"


class BaseModelForm(forms.ModelForm):
    required_css_class = "required"


class SearchFieldInput(forms.TextInput):

    def render(self, name, value, attrs=None, **kwargs):
        field = super(SearchFieldInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-group">
            {1}
             <span class="input-group-btn">
                <button class="btn btn-default" type="button"><i class="glyphicon glyphicon-search"></i></button>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)


class DatepickerInput(forms.DateInput):
    def __init__(self, *args, **kwargs):
        kwargs['format'] = "%Y-%m-%d"
        super(DatepickerInput, self).__init__(*args, **kwargs)

    def render(self, name, value, attrs=None, renderer=None):

        date_format = "yyyy-MM-dd"

        if "format" not in self.attrs:
            attrs['format'] = date_format

        if "data-format" not in self.attrs:
            attrs['data-format'] = date_format

        field = super(DatepickerInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-append date datepicker" data-provide="datepicker" {0}>
            {1}
            <span class="add-on">
                <i data-time-icon="icon-time" data-date-icon="icon-calendar"></i>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)


class DateTimePickerInput(forms.DateTimeInput):
    def __init__(self, *args, **kwargs):
        kwargs['format'] = "%Y-%m-%d %H:%M"
        super(DateTimePickerInput, self).__init__(*args, **kwargs)

    def render(self, name, value, attrs=None):

        date_format = "yyyy-MM-dd hh:mm"

        if "data-format" not in self.attrs:
            attrs['data-format'] = date_format
        if "class" not in self.attrs:
            attrs['class'] = 'input-medium'

        field = super(DateTimePickerInput, self).render(name, value, attrs)
        final_attrs = self.build_attrs(attrs)

        output = format_html(u'''
         <div class="input-append date datetimepicker" {0}>
            {1}
            <span class="add-on">
                <i data-time-icon="icon-time" data-date-icon="icon-calendar"></i>
            </span>
        </div>
        ''', flatatt(final_attrs), field)

        return mark_safe(output)

servo/templates/products/category_form.html
{% extends "modal.html" %}
{% load i18n %}

{% block header %}
    {% trans "Edit Product Group" %}
{% endblock header %}

{% block body %}
    <form action="{{ request.path }}" method="post" class="form-horizontal">
        {% csrf_token %}
        {% include "form_snippet.html" %}
    </form> 
{% endblock body %}

servo/templates/products/choose.html
{% extends "modal.html" %}
{% load i18n %}

{% block header %}
    {% trans "Search for a product" %}
{% endblock header %}

{% block body %}
    <form method="post" action="{{ action }}" accept-charset="utf-8" data-target="#search-results" id="search-form">
        {% csrf_token %}
        <input type="text" style="width:500px" class="search-query" name="q" autocomplete="off" placeholder="{% trans "Code, title or category" %}"/>
    </form>
    <div id="search-results"></div>
{% endblock body %}

{% block footer %}
    <button class="btn" data-dismiss="modal" aria-hidden="true">{% trans "Close" %}</button>
    <a class="btn btn-primary submit-search" href="#">{% trans "Search" %}</a>
    <script type="text/javascript">
        $('.submit-search').click(function(e){
            $('#search-form').submit();
            e.preventDefault();
        });
    </script>
{% endblock footer %}

servo/templates/products/delete_category.html
{% extends "modal.html" %}
{% load i18n %}

{% block header %}
    {% trans "Delete product category?" %}
{% endblock header %}

{% block body %}
    {% trans "This action will not delete the products in this category." %}
{% endblock body %}

{% block footer %}
    <form method="post" action="{{ action }}">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger">{% trans "Delete" %}</button>
    </form>
{% endblock footer %}

servo/templates/products/get_info.html
{% extends "modal.html" %}
{% load servo_tags %}
{% load i18n %}

{% block header %}
{% trans "Product Info" %}
{% endblock header %}

{% block body %}
<div class="media">
  <a class="pull-left" href="#">
    <img class="media-object" src="{{ product.get_photo }}" data-src="{{ product.get_photo }}" width="64px"/>
  </a>
  <div class="media-body">
    <h4 class="media-heading">{{ product.code }}</h4>
    <p>{{ product.title }}</p>
    <p>{{ product.description|default:"" }}</p>
  </div>
</div>
<dl class="dl-horizontal">
  <dt>{% trans "Stock Price" %}</dt>
  <dd>{{ product.price_sales_stock|currency }}</dd>
  <dt>{% trans "Exchange Price" %}</dt>
  <dd>{{ product.price_sales_exchange|currency }}</dd>
  {% if product.component_code %}
  <dt>{% trans "Component Group" %}</dt>
  <dd>{{ product.get_component_code_display }} ({{ product.get_part_type_display }})</dd>
  {% endif %}
</dl>
<dl class="dl-horizontal">
  <dt>{% trans "EEE Code" %}</dt>
  <dd>{{ product.eee_code|default:"-"|addspace }}</dd>
</dl>
{% for i in inventory %}
{% ifchanged i.location.id %}
<hr/>
<h4>{{ i.location.title }}</h4>
{% endifchanged %}
<dl class="dl-horizontal">
  <dt>{% trans "Stocked" %}</dt>
  <dd>{{ i.amount_stocked|default:"-" }}</dd>
  <dt>{% trans "Ordered" %}</dt>
  <dd>{{ i.amount_ordered|default:"-" }}</dd>
  <dt>{% trans "Reserved" %}</dt>
  <dd>{{ i.amount_reserved|default:"-" }}</dd>
</dl>
{% empty %}
  <hr/>
  <div class="muted text-center">{% trans "Product not in inventory" %}</div>
{% endfor %}
{% endblock body %}

{% block footer %}
{% if product.pk %}
  <a class="btn btn-default" href="{{ product.get_absolute_url }}">{% trans "View" %}</a>
  <a class="btn btn-default" href="{% url 'products-edit_product' pk=product.pk group='all' %}">{% trans "Edit" %}</a>
{% endif %}
  <button type="submit" class="btn btn-primary" data-dismiss="modal">{% trans "Done" %}</button>
{% endblock footer %}

servo/templates/products/index.html
{% extends "default.html" %}
{% load i18n %}
{% load mptt_tags %}
{% load servo_tags %}

{% block toolbar %}
<div class="btn-group">
  {% if perms.servo.add_product %}
  <a class="btn" href="{% url 'products-create' group=group.slug %}"><i class="icon-plus"></i> {% trans "New Product" %}</a> 
  <a class="btn dropdown-toggle" data-toggle="dropdown" href="#"><span class="caret"></span></a>
  <ul class="dropdown-menu">
    <li><a href="{% url 'products-create_category' %}" data-modal="#modal">{% trans "New Category" %}</a></li>
    <li class="divider"></li>
  {% if product.id and perms.servo.add_purchaseorder %}
    <li><a href="{% url 'orders-create_with_product' product_id=product.id %}">{% trans "New Sales Order" %}</a></li>
    <li><a href="{% url 'purchases-create_po' product_id=product.id %}">{% trans "New Purchase Order" %}</a></li>
  {% else %}
    <li class="disabled"><a href="">{% trans "New Sales Order" %}</a></li>
    <li class="disabled"><a href="">{% trans "New Purchase Order" %}</a></li>
  {% endif %}
  </ul>
  {% endif %}
</div>
<div class="btn-group">
  <a class="btn dropdown-toggle" data-toggle="dropdown" href="#">
    <i class="icon-cog"></i> <span class="caret"></span>
  </a>
  <ul class="dropdown-menu">
  {% if group.pk and perms.servo.add_product %}
    <li><a href="{% url 'products-edit_category' group.slug %}" data-modal="#modal">{% trans "Edit Category" %}</a></li>
    <li><a href="{% url 'products-delete_category' group.slug %}" data-modal="#modal">{% trans "Delete Category" %}</a></li>
  {% else %}
    <li class="disabled"><a href="#">{% trans "Edit Category" %}</a></li>
    <li class="disabled"><a href="#">{% trans "Delete Category" %}</a></li>
  {% endif %}
    <li class="divider"></li>
    <li><a href="{% url 'products-download' group.slug %}">{% trans "Download Products" %}</a></li>
    <li><a href="{% url 'products-get_inventory_report' %}">{% trans "Download Inventory Report" %}</a></li>
    <li class="divider"></li>
    <li><a href="{% url 'products-upload_prices' %}" data-modal="#modal">{% trans "Upload Prices" %}</a></li>
    <li><a href="{% url 'products-upload_products' %}" data-modal="#modal">{% trans "Upload Products" %}</a></li>
    <li><a href="{% url 'products-upload_gsx_parts' %}" data-modal="#modal">{% trans "Upload Parts Database" %}</a></li>
  </ul>
</div>
{% endblock toolbar %}

{% block content %}
<div class="row-fluid row-header">
  <div class="span12">
    <form class="form-search pull-right">
      <div class="input-append">
        <input type="text" class="search-query filter" placeholder="{% trans "Filter results" %}"/>
        <button type="button" class="btn" data-toggle="collapse" data-target="#collapsable"><i class="icon-search"></i></button>
      </div>
    </form>
  </div>
</div>
{% include "products/tabs.html" %}
<div class="row-fluid">
  {% block second_column %}
  <div class="span3">
    <ul class="nav nav-list">
      <li class="nav-header">{% trans "Categories" %}</li>
      <li class="{% active request 'all' %}"><a href="{% url 'products-list_products' %}">{% trans "All" %}</a></li>
      {% recursetree categories %}
      <li class="{% active request 'products' node.slug %}">
        <a href="{% url 'products-list_products' group=node.slug %}">{{ node.title }}</a>
        {% if not node.is_leaf_node %}
        <ul class="nav nav-list">{{ children }}</ul>
        {% endif %}
      </li>
      {% endrecursetree %}
    </ul>
  </div>
  <div class="span9">
    <div id="collapsable" class="collapse out">
      <form method="post" action="" class="form-inline">
        {% csrf_token %}
        {% for field in form %}
        <div class="control-group pull-left">
          <label class="control-label">{{ field.label|default:"&nbsp;" }}</label>
          <div class="controls">{{ field }}</div>
        </div>
        {% endfor %}
        <p class="clearfix"><hr/></p>
        <div class="pull-right">
          <button type="submit" class="btn btn-primary"><i class="icon-search icon-white"></i> {% trans "Search" %}</button>
        </div>
      </form>
    </div>
    {% include "products/list.html" %}
    {% include "pagination.html" with items=products %}
  </div>
  {% endblock second_column %}

  {% block third_column %}
  
  {% endblock third_column %}
</div>
{% endblock content %}

{% block crumbs %}
<li><a href="{% url 'products-list_products' %}">{% trans "Products" %}</a></li>
{% block breadcrumb %}
<li class="active"><span class="divider">/</span>{{ group_name }}</li>
{% endblock breadcrumb %}
{% endblock crumbs %}

servo/templates/products/list_rows.html
{% load i18n %}
{% load servo_tags %}
{% for p in products %}
{% with p.get_pk as product_id %}
<tr>
  <td><img src="{{ p.get_photo }}" alt="{{ product }}" class="img-icon"/></td>
  <td data-value="{{ p.code }}">
    <a href="{% url 'products-view_product' pk=p.pk group=group.slug %}"><strong>{{ p.code }}</strong></a><br/>
    {{ p.title }}<br/><small class="muted">{{ p.eee_code|default:""|addspace }}</small>
  </td>
  <td data-value="{{ p.price_sales_stock|safe }}" title="{% trans 'Stocking Price' %}">{{ p.price_sales_stock|currency }}</td>
  <td data-value="{{ p.price_sales_exchange|safe }}" title="{% trans 'Exchange Price' %}">{{ p.price_sales_exchange|currency }}</td>
  {% if p.is_service %}
  <td>&infin;</td>
  {% else %}
  <td title="{% trans 'Amount at your current location' %}">{{ p|amount_in_location:request.user }}</td>
  {% endif %}
  <td>
    <div class="btn-group pull-right">
    {% if perms.servo.change_product %}
      <a class="btn" href="{% url 'products-edit_product' pk=product_id group=group.slug %}"><i class="icon-pencil"></i></a>
    {% else %}
      <a class="btn disabled" href="#"><i class="icon-pencil"></i></a>
    {% endif %}
      <button class="btn dropdown-toggle" data-toggle="dropdown">
        <span class="caret"></span>
      </button>
      <ul class="dropdown-menu">
      {% with request.session.current_order_id as co %}
        {% if co %}
        <li><a href="{% url 'orders-add_product' co product_id %}">{% trans "Use in Service Order" %} #{{ request.session.current_order_code }}</a></li>
        <li class="divider"></li>
        {% endif %}
      {% endwith %}
        <li><a href="{% url 'orders-create_with_product' product_id %}">{% trans "Create Sales Order" %}</a></li>
        <li><a href="{% url 'purchases-create_po' product_id=product_id %}">{% trans "Create Purchase Order" %}</a></li>
        {% with request.session.current_po as po_pk %}
        {% if po_pk %}
        <li><a href="{% url 'purchases-add_to_po' pk=po_pk product_id=product_id %}">{% trans "Use in Purchase Order" %}</a></li>
        {% endif %}
      {% endwith %}
        <li class="divider"></li>
        {% if perms.servo.delete_product %}
        <li><a href="{% url 'products-delete_product' pk=product_id group=group.slug %}" data-modal="#modal"><i class="icon-trash"></i> {% trans "Delete" %}</a></li>
        {% else %}
        <li class="disabled"><a href="#"><i class="icon-trash"></i> {% trans "Delete" %}</a></li>
        {% endif %}
      </ul>
    </div>
  </td>
</tr>
{% endwith %}
{% empty %}
<tr><td colspan="6" class="muted empty">{% trans "No products found" %}</td></tr>
{% endfor %}

servo/templates/products/remove.html
{% extends "modal.html" %}
{% load i18n %}

{% block header %}
    {% blocktrans with code=product.code %}Really delete product "{{ code }}"?{% endblocktrans %}
{% endblock header %}

{% block footer %}
    <form action="{{ action }}" method="post">
        {% csrf_token %}
        <button type="submit" class="btn btn-danger">{% trans "Delete" %}</buttom>
    </form>
{% endblock footer %}

servo/templates/products/view_incoming.html
{% extends "shipments/list_incoming.html" %}